\ Non-standard definitions in standard Forth.
\
\ Copyright (C) 2007  Joshua I. Grams
\ May be used, modified, and redistributed without limitation.

require modules.fs

begin-module

: environment ( "name" -- i*x )
	parse-word environment? 0= abort" Environmental query failed" ;

environment ADDRESS-UNIT-BITS constant ADDRESS-UNIT-BITS
1 cells ADDRESS-UNIT-BITS * constant CELL-BITS

create colon 2 c, char : c, bl c, 80 chars allot

public:

: append ( c-addr1 u1 c-addr2 u2 -- c-addr1 u3 )
	dup >r  2over chars + swap chars move  r> + ;

: define ( c-addr u -- colon-sys )  colon char+ 2 2swap append evaluate ;

: peek-word ( -- c-addr u )  >in @  parse-word  rot >in ! ;

: ext16 [ CELL-BITS 16 - ] literal lshift 65536 / ;

end-module
